/*
    YAM - Yet Another Mod player
    Copyright 2001, 2002 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <esd.h>
#include "audio.h"

static int audio;
static int stop;
static int playing = 0;

int channels = 2;
int samplerate = 44100;
int bitdepth = 16;
int sig = 1;
int littleendian = 1;

int init_audio(void) {
	int esd_format = ESD_BITS16 | ESD_STEREO | ESD_STREAM | ESD_PLAY;
	unsigned int key = ESD_ENDIAN_KEY;
	unsigned char *ptr = (unsigned char*) &key;

	if (*ptr=='E') littleendian = 0;
	else littleendian = 1;

	if ((audio=esd_play_stream(esd_format,samplerate,NULL,"Mod player"))<0) {
		fprintf(stderr,"Can't open connection to ESD\n");
		return 0;
	}

	return 1;
}

void stop_audio(void) {
	esd_close(audio);
}

void start_play(read_func rf, void *ptr) {
	unsigned char buffer[4096];
	int n;
	stop = 0;
	playing = 1;
	while (!stop) {
		n = rf(ptr,buffer,sizeof(buffer));
		if (n<=0) break;
		write(audio,buffer,n);
	}
	playing = 0;
}

int is_playing(void) {
	return playing;
}

void break_play(void) {
	stop = 1;
}

